<template>
  <div class="row bg-white p-3">
    <div class="col-md-12">
      <DxDataGrid
        :allow-column-reordering="true"
        :data-source="items"
        key-expr="id"
        :show-borders="true"
        @exporting="onExporting"
      >
        <DxExport :enabled="true" :allow-export-selected-data="true" />
        <DxColumn data-field="client.name" caption="Cliente" />
        <DxColumn data-field="products.name" caption="Producto" />
        <DxColumn data-field="products.code" caption="Código" />
        <DxColumn data-field="quantity" caption="Cantidad" alignment="center" />
        <DxColumn
          data-field="total"
          summary-type="custom"
          value-format="currency"
          caption="Precio"
          alignment="center"
        />
        <DxSummary>
          <DxGroupItem
            column="client.name"
            summary-type="count"
            display-format="{0} items"
          />
          <DxGroupItem
            column="quantity"
            :align-by-column="true"
            summary-type="sum"
            display-format="Total: {0}"
          />
          <DxGroupItem
            column="total"
            :align-by-column="true"
            value-format="currency"
            summary-type="sum"
            display-format="{0}"
          />
          <DxTotalItem column="quantity" summary-type="sum" />
          <DxTotalItem column="total" summary-type="sum" />
        </DxSummary>
        <DxColumn :group-index="0" data-field="num_orden" caption="Orden" />

        <DxGroupPanel :visible="true" />
        <DxGrouping :auto-expand-all="true" />
        <DxPaging :page-size="10" />
        <DxSearchPanel :visible="true" />
      </DxDataGrid>
    </div>
  </div>
</template>
<script lang="ts">
import axios from "axios";
import Vue from "vue";
import { Workbook } from "exceljs";
import { saveAs } from "file-saver-es";
import { exportDataGrid } from "devextreme/excel_exporter";
import {
  DxDataGrid,
  DxColumn,
  DxGrouping,
  DxGroupPanel,
  DxSearchPanel,
  DxPaging,
  DxGroupItem,
  DxTotalItem,
  DxSummary,
  DxExport,
} from "devextreme-vue/data-grid";
export default Vue.extend({
  name: "table-invoice",
  components: {
    DxColumn,
    DxGroupPanel,
    DxGrouping,
    DxPaging,
    DxGroupItem,
    DxSummary,
    DxTotalItem,
    DxSearchPanel,
    DxDataGrid,
    DxExport,
  },
  data() {
    return {
      items: [],
    };
  },
  mounted() {
    this.loadInvoice();
  },
  methods: {
    loadInvoice() {
      axios.get("invoice").then((res) => {
        res.data.map((el: any) => {
          el.total = el.products.price_sale + el.quantity;
          console.log(el.total);
        });
        this.items = res.data;
      });
    },
    onExporting(e) {
      const workbook = new Workbook();
      const worksheet = workbook.addWorksheet("Employees");

      exportDataGrid({
        component: e.component,
        worksheet,
        autoFilterEnabled: true,
      }).then(() => {
        workbook.xlsx.writeBuffer().then((buffer) => {
          saveAs(
            new Blob([buffer], { type: "application/octet-stream" }),
            "DataGrid.xlsx"
          );
        });
      });
      e.cancel = true;
    },
  },
});
</script>
